;   12     
; - AtTiny15
; -  
;  - 25.3.21o
;  - 
; omercury@yandex.ru
;*********************************************
;fuse 
.include "tn15def.inc"
.device ATtiny15
;**********  Variables  ************* 
.include "Remote_On-Off_Var.asm"
;********  End Variables  ***********
.CSEG
.org 0
	rjmp	Reset					;
	rjmp	Ext_INT0				; External Interrupt Request 0
	reti	;rjmp	PCI				; Pin Change Interrupt
	reti	;rjmp	Tim1_CompA		; Timer/Counter1 Compare Match A
	reti	;rjmp	Tim1_OVF		; Timer/Counter1 Overflow
	rjmp	Tim0_OVF		; Timer/Counter0 Overflow
	reti	;rjmp	EERDY			; EEPROM Ready
	reti	;rjmp	ACI				; Analog Comparator Conversion Complete
	reti	;rjmp	ADC_Comp		; ADC Conversion Complete
;********************************************************************************
;	INT_VECTORS_SIZE	= 9	; size in words
;********************************************************************************

;*****************************************************
;         '0'     *
;*****************************************************
Tim0_OVF:	in	tempSreg,SREG	; 
		ldi		temp1,Delay_1125us
		out		TCNT0,temp1		; 
		tst		Delay
		breq	TMR_Exit
		dec		Delay
		out		SREG,tempSreg	; 
TMR_Exit:	reti
;*****************************************************
; ---  ---
;*****************************************************
Reset:		cli					; 

	ldi		temp,(1<<LED)|(0<<IRR)|(1<<Clk)|(1<<Dout)	;IRR (PB2)  x
	out		DDRB,temp
	ldi		temp,(1<<LED)|(1<<IRR)|(1<<Clk)|(0<<Dout)	;LED+Clk  "1"
	out		PortB,temp
	Reset_TMR			; 
	ldi		Count,InChange
;*****************************************************
;   0
	ldi		temp,0b00000001		; 0-1  INT0 (01 - any change)
	out		MCUCR,temp			; 
	ldi		temp,(1<<INT0)		;  6 - INT0
	out		GIMSK,temp			;  
	sei					;  
;*****************************************************
clr		NoFirst
clr		lastADC
;*****************************************************
clr	r27	;
Main:
	;    
		ldi		temp,ADCin		;    
		out		ADMUX,temp		;
ADC_cicle:
		ldi		temp,0b11000011	;INT disable
		out		ADCSR,temp			; ()
ADC_wait:
		sbis	ADCSR,ADIF			;   
		rjmp	ADC_wait			;   - 
		in		temp,ADCL			; -  
		tst		NoFirst				;  
		brne	NoRead				;   - 
		mov		lastADC,temp		; 
		inc		NoFirst				; 
		rjmp	EndADC				; 
NoRead:	cp		temp,lastADC		;   
		brne	EndADC				;   - 
		cpi		NoFirst,NumADC+1	;  
		brlo	EndADC				;   - 
		rcall	ExeCmd			; 
EndADC:
		tst		Delay				; 1
		breq	Faul
		cpi		Count,0
		brne	Main
		tst	r27
		brne	Main
		StCmd
	;	rjmp	Main

	cli					; 
		rcall	SendLed
		inc	r27
Faul:
;		ldi		Count,InChange
		ClrSc
		clr		NoFirst
		rjmp	Main
;*****************************************************
;     -  IR 
;  -  +   sc0-sc3(sc4) 32 
;*****************************************************
Ext_INT0:		;PB2
		in		tempSreg,SREG	; 
		cpi		Count,InChange-2
		brlo	ResData		;  
		cpi		Count,InChange-2;   -   
		breq	End_Start

		sbic	PinB,	IRR	; 0,  "1"(skip if 0)
		rjmp	Start_1		;  
Start_0:			;  "0"
		ldi		Delay,	10	; 20   (20 * 225 = 4,5 )
		rjmp	EndRes		; 
Start_1:			;  "1"
		cpi		Delay,	2	;  ,   4,05  -  
		brge	Err_Int
		ldi		Delay,	10	; 20   (20 * 225 = 4,5 )
		rjmp	EndRes		; 
;   
End_Start:		; "0"  
		cpi		Delay,	2	;  ,   4,05  -  
		brge	Err_Int
		rjmp	EndDel		; 
ResData:	; "1"  "0"
		cpi		Delay,5		;   0,375 
		brge	Err_Int
	sbis	PinB,	IRR	;  1 -   
	rjmp	ExeZero;EInt
ExeOne:				; "1"
		cpi		Delay,4		;   0,375 
		brne	Err_Int
		rjmp	EInt
ExeZero:			; "0"
		cpi		Delay,3		;  (6*225=1,35)
		brlo	Set_1		; 1  (1,125 ) -> "1"
Set_0:						; 1  (1,125 ) -> "0"
		clc					; "0"   
		rjmp	End_SB
Set_1:	sec					; "1"   
End_SB:	RolCmd				;   
EndDel:	ldi		Delay,5		; 1   (1,125 )
EndRes:			Resync_TMR	; 
EndInt:	dec		Count			; 
		brne	EInt
	StCmd					; 
EInt:	out		SREG,tempSreg	; 
		reti
Err_Int:
	ldi		Delay,	0
	ldi		Count,InChange	; 
	rjmp	EInt		;  
;*****************************************************
;			rjmp	Main
;*****************************************************
;   HT1611 Command_0 - Command_4 (40 )
;*****************************************************
SendLed:	cbi		PORTB,Dout		;Dout  "0"
		ldi		Count,InChange
		ldi		SendCnt,8*5		; 40 
SendCicle:
	;	sbrc	Command_4,7		;  7     - 
		sbrc	sc4,7
		sbi		PORTB,Dout		;Dout  "1"
		cbi		PORTB,Clk		;
	ldi		SendDelReg,SendDel	;
Wait:							; 
	nop	nop	nop
	dec		SendDelReg
	brne	Wait				; 
			RolSc
		sbi		PORTB,Clk		; 
		cbi		PORTB,Dout		;Dout  "0"
		dec		SendCnt			; 
		brne	SendCicle		; 
		ret
;*****************************************************
;ExeRes:
ExeCmd:	ret
;*****************************************************
			rjmp	Main
