;**********  Variables  ************* 
; ---   ---
.equ	Dout	=	0		;PB0 -  
.equ	Clk		=	1		;PB1 - 
.equ	IRR		=	2		;PB2 -  
.equ	LED		=	3		;PB3 - LED (/)
.equ	ADCin	=	0b00100011	;AREF=Vcc(00),  (b5 - 1)  - ADC3(b3-0 - 011)
;	
.equ	osc	=	16000000			;   1.6MHz
.equ	DelConst		=	1125	;  
.equ	Delay_1125us	=	-74	;((osc/(1/((DelConst-5)/1000000)))/8)
.equ	InChange		=	32+2	;    (32 +2 . )
.equ	SendDel	=	255;220		;    HT1611
.equ	NumADC	=	3			;  
.equ	RemSys	=	$B838		;  Remote
; ---    ---
.def	Command_0	= R5;21			;    
.def	Command_1	= R6;22
.def	Command_2	= R7;23
.def	Command_3	= R8;24
;.def	Command_4	= R9;25
;.def	NoFirst	=	r8	; 
.def	lastADC	=	r9	;  
.def	sc0	=	r10
.def	sc1	=	r11
.def	sc2	=	r12
.def	sc3	=	r13
.def	sc4	=	r14
.def	TempSreg	=	R15		;  SREG
.def	temp	=	R16			; 1
.def	temp1	=	R17			; 2 (   )
.def	Count	=	R18			; 
.def	Delay		=	R19		;  	Timer0
.def	NoFirst		=	r20		; 

.def	SendCnt		=	R29	;    
.def	SendDelReg	=	R30	;     
;********************************************************************************

;********  End Variables  ***********
.macro	Int_TMR			;  Timer0
	in	temp,TIMSK
	sbr	temp,(1<<TOIE0)
	out	TIMSK,temp
.endm
.macro	Stop_Int_TMR	;  Timer0
	in	temp,TIMSK
	cbr	temp,(1<<TOIE0)
	out	TIMSK,temp
.endm
.macro	Start_TMR		; Timer0
	ldi	temp,2
	out	TCCR0,temp
.endm
.macro	Stop_TMR		; Timer0
	clr	temp
	out	TCCR0,temp
.endm
.macro	Resync_TMR		; 
	ldi	temp,Delay_1125us
	out	TCNT0,temp
.endm
.macro	Reset_TMR		; Timer0
	ldi	temp,2
	out	TCCR0,temp
	ldi	temp,Delay_1125us
	out	TCNT0,	temp
	in	temp,TIMSK
	sbr	temp,(1<<TOIE0)
	out	TIMSK,temp
.endm
;.macro	Int_TMR1		;  Timer1
;	in	temp,TIMSK
;	sbr	temp,(1<<TOIE1)
;	out	TIMSK,temp
;.endm
;.macro	Stop_Int_TMR1	;  Timer1
;	in	temp,TIMSK
;	cbr	temp,(1<<TOIE1)
;	out	TIMSK,temp
;.endm
;.macro	Start_TMR1	; Timer1
;	ldi	temp,8
;	out	TCCR1,temp
;.endm
;.macro	Stop_TMR1	; Timer1
;	clr	temp
;	out	TCCR1,temp
;.endm
;.macro	Resync_TMR1	; 
;	ldi	temp,SendDel
;	out	TCNT1,temp
;.endm
;.macro	Reset_TMR1	; Timer1
;	ldi	temp,8
;	out	TCCR1,temp
;	ldi	temp,SendDel
;	out	TCNT1,temp
;	in	temp,TIMSK
;	sbr	temp,(1<<TOIE1)
;	out	TIMSK,temp
;.endm
.macro	StCmd
	mov	sc0,Command_0
	mov	sc1,Command_1
	mov	sc2,Command_2
	mov	sc3,Command_3
;	mov	sc4,Command_4
.endm
.macro	RolSc
	lsl	sc0
	rol	sc1
	rol	sc2
	rol	sc3
;	rol	sc4
.endm
.macro	RolCmd
	rol	Command_0	;   
	rol	Command_1	;
	rol	Command_2
	rol	Command_3
;	rol	Command_4
.endm
.macro	ClrCmd
	clr	Command_0
	clr	Command_1
	clr	Command_2
	clr	Command_3
;	clr	Command_4
.endm
.macro	ClrSc
	clr	sc0
	clr	sc1
	clr	sc2
	clr	sc3
;	clr	sc4
.endm
